import numpy as np
import math

# max number of polymers
# max number of segments x2>=2*x1
# alpha, 1 or 4/3, fix this value for now
# always use default configuration assumption, 1
# molar weight 
# number of polymers in each component is fixed to [5000,5000]
# num of monomers in an entanglement length, Ne(PE)~35, could use from 30 to 40
# density fixed, 785-925
# sideArms is for Comb structure, average number of side arms permolecule



## some changes
#### get rid of design var numComponents. Final num of components depend on composition
#### if composition < 1E-5 (0.001%), I assume that component does not exisit in the mixture 

class Rheology(object):
    def __init__(self,max_mol,max_seg,alpha,molar_w, num_monomer, density,taue,T,numComponents,composition,numPolymers,polymerType,armType,Mw,PDI,numArms):
        self.max_mol = max_mol
        self.max_seg = max_seg
        self.alpha = alpha
        self.molar_w = molar_w
        self.num_monomer = num_monomer
        self.density = density
        self.taue = taue
        self.T = T
        self.numComponents = numComponents
        self.composition = composition
        self.numPolymers = numPolymers
        self.polymerType = polymerType
        self.armType = armType
        self.Mw = Mw
        self.PDI = PDI
        self.numArms = numArms
        #self.sideArms = sideArms
        #self.CayleyGen = CayleyGen # number of cayley tree generations

    def generateInput(self,filename):
        file = open(filename,'w')
        file.write(str(self.max_mol)+"\t"+str(self.max_seg)+"\n")
        file.write(str(self.alpha)+"\n")
        file.write("1 \n")
        file.write(str(self.molar_w)+'\t'+str(self.num_monomer)+'\t'+str(self.density)+"\n")
        file.write(str(self.taue)+"\t"+str(self.T)+"\n")
        file.write(str(self.numComponents)+"\n")

        for i in range(self.numComponents):
            file.write(str(self.composition[i])+"\n")
            file.write(str(self.numPolymers[i])+"\t"+str(self.polymerType[i])+"\n")

            if self.polymerType[i]==0:
                file.write(str(self.armType[i])+"\t"+str(self.Mw[i])+"\t"+str(self.PDI[i])+"\n")

            if self.polymerType[i]==1:
                file.write(str(self.armType[i])+"\n")
                file.write(str(self.Mw[i])+"\t"+str(self.PDI[i])+"\n")
                file.write(str(self.numArms[i])+"\n")
            if self.polymerType[i]==2:
                file.write(str(self.armType[i][0])+"\n")
                file.write(str(self.Mw[i][0])+"\t"+str(self.PDI[i][0])+"\n")
                file.write(str(self.armType[i][1])+"\n")
                file.write(str(self.Mw[i][1])+"\t"+str(self.PDI[i][1])+"\n")
            if self.polymerType[i]==3:
                file.write(str(self.armType[i][0])+"\n")
                file.write(str(self.Mw[i][0])+"\t"+str(self.PDI[i][0])+"\n")
                file.write(str(self.armType[i][1])+"\n")
                file.write(str(self.Mw[i][1])+"\t"+str(self.PDI[i][1])+"\n")
            if self.polymerType[i]==4:
                file.write(str(self.armType[i])+"\n")
                file.write(str(self.Mw[i])+"\t"+str(self.PDI[i])+"\n")
                file.write(str(self.sideArms[i])+"\n")
            if self.polymerType[i]==5:
                file.write(str(self.CayleyGen[i])+"\n")
                for j in range(self.CayleyGen[i]):
                    file.write(str(self.armType[i][j])+"\t"+str(self.Mw[i][j])+"\t"+str(self.PDI[i][j])+"\n")
        file.close()
