import generateBob
import os
import pandas as pd
import numpy as np 
import sys
# molar weight 
# number of polymers in each component is fixed to [5000,5000]
# num of monomers in an entanglement length, Ne(PE)~35, could use from 30 to 40
# density fixed, 785-925
# sideArms is for Comb structure, average number of side arms permolecule



dirpath = os.getcwd()
target_file = pd.read_csv(dirpath+'/bob_target.dat',header=None, sep=',', engine='python')
max_mol,max_seg = target_file.iloc[0].values[0].split()

alpha = float(target_file.iloc[1].values)
molar_w, num_monomer, density = target_file.iloc[3].values[0].split()
taue, T = target_file.iloc[4].values[0].split()
numComponents = int(target_file.iloc[5].values)

numPolymers1, polymerType1 = target_file.iloc[7].values[0].split()
armType1 = int(target_file.iloc[8].values)

numArms1 = int(target_file.iloc[10].values)
numPolymers2, polymerType2 = target_file.iloc[12].values[0].split()
armType2 = int(target_file.iloc[13].values)
numArms2 = int(target_file.iloc[15].values)


def updateInp(myin):

    myinfile = open(myin,'r')
    myinData = myinfile.readlines()

    myinData = [float(x.strip()) for x in myinData]
    composition = []
    composition = [myinData[0], 1-myinData[0]]

    Mw = myinData[2*0+1:2*1+1]
    PDI = myinData[2*1+1:2*2+1]
    #polymerType = [int(x) for x in myinData[2*2+1:2*3+1]]
    #armType = [int(x) for x in myinData[2*3+1:2*4+1]]
    #numArms = [int(x) for x in myinData[2*4+1:2*5+1]]

    R = generateBob.Rheology(int(max_mol),int(max_seg),float(alpha),float(molar_w), int(num_monomer), float(density),float(taue),
        float(T),numComponents,composition,[int(numPolymers1),int(numPolymers2)],[int(polymerType1),int(polymerType2)],
        [armType1,armType2],Mw,PDI,[numArms1,numArms2])
    R.generateInput(dirpath+"/inp.dat")

updateInp(sys.argv[1])

