import numpy as np
import sys
import os
import pandas as pd
import math

dirpath = os.getcwd()
def rescale(values):
    value_diff = values - min(values)
    scaled_value = value_diff/max(values)
    return scaled_value

def sortData(filename):
    df = pd.read_csv(filename,delimiter=" ", header=None)
    data = df.loc[(df[0]>=0.01) & (df[0]<=10000)]
    gp,gpp = data[1], data[2]
    
    gp, gpp = rescale(gp), rescale(gpp)
    return gp.values, gpp.values



def complexmodulus(gp,gpp):
    
    gstar = [np.sqrt(gp[i]**2 + gpp[i]**2) for i in range(len(gp))]
    
    return gstar

def obj(pred,sim):
    return sum((pred[i] - sim[i])**2 for i in range(len(pred)))
    


targetfile = dirpath+"/target/gtp_target.dat"
datafile = dirpath+"/gtp.dat"
target_gp, target_gpp = sortData(targetfile)
gp, gpp = sortData(datafile)

targetgs, predgs = complexmodulus(target_gp, target_gpp), complexmodulus(gp, gpp)
obj(targetgs, predgs)

